Subject: Re: bug#62994: [PATCH 3/3] Add support for colored underlines on tty frames

From: Eli Zaretskii <[email-masked]>
Date: Fri, 21 Apr 2023 20:56:18 +0300

> From: Mohsin Kaleem <[email-masked]>
> Date: Fri, 21 Apr 2023 18:10:39 +0100
> 
> > It looks like your edits use indentation with only spaces.  Our style
> > in C sources is to use TABs and spaces, so please set up your Emacs to
> > follow our style (it should happen automatically if you let Emacs read
> > and follow the .dir-locals.el file in the Emacs repository).
> 
> Looks like .dir-locals.el won't work for me since I use c-ts-mode and it
> hooks into c-mode only.

You are right, I've just fixed that.

> >> +  if (tty->TF_set_underline_style)
> >> +    tty->TF_set_underline_color = "\x1b[58:2::%p1%{65536}%/%d:%p1%{256}%/%{255}%&%d:%p1%{255}%&%dm";
> >
> > What is the source for this escape sequence? can you mention it in a
> > comment?
> 
> The form here is nonstandard. It's adapted from the same escape sequence
> used by neovim [1]. The difference here is that this form accepts a
> single color parameter whereas that one accepts three different
> parameters for the color range. Since this form is how the existing
> foreground and background sequences are set AND the sequence doesn't
> come from a termcap I figured it was okay to adapt it to a form Emacs
> can already substitute.
> 
> [1]: https://github.com/neovim/neovim/blob/42f492ac99058bd1cd56c3c7871e7e464b2a5e24/src/nvim/tui/tui.c#L1932

This should all be in a comment there, thanks.